#include "rm67162.h"
#include "TFT_eSPI.h"
#include <Arduino.h>
#include <SPI.h>
#include <SD.h>
#include "WS_QMI8658.h"
#include <Wire.h>
#include <vector>
#include "JpegFunc.h"
#include "FS.h"
#include "SD_MMC.h"
#include "FT3168.h"
#include "middleFont.h"
#include "hugeFatFont.h"
#include "fatFont.h"
#include "smallFont.h"
#include <WiFi.h>
#include <BleKeyboard.h>
#include <JPEGDecoder.h>
//=========Running light===================//
#define s 15
#define T 100
//定义LED管脚
const int led_pin[s]={43,44,2,3,11,12,13,14,15,21,38,4,10,16,17};
char a,b,i;

//=========Running light===================//

//=========BLE===========================//
BleKeyboard bleKeyboard;
//=========BLE=========================//

//============WIFI====================//
const char *ssid = "ESP32S3-AMOLED-1.91";
const char *password = "88888888";
//============WIFI===================//

//==========Display and touch======//
uint32_t PSRAM_Size;
uint32_t cardSize;
char str1[20];
TFT_eSPI tft= TFT_eSPI();
TFT_eSprite sprite = TFT_eSprite(&tft);
static uint8_t image_index = 1;
static int16_t x, y;
static bool mountSD = false;

// spi_device_handle_t spi;
uint8_t _brightness;


int screenW=536;
int screenH=240;

int start=1;
unsigned short imageS[128640]={0}; // edit this screenW * screen H
String name[100];
String fileName[100];
String tmp,tmp2;
int numTabs=0,numTabs2=0;
int number=1;
File root;

// char str1[20];
String Str_cardSize;
// TFT_eSPI tft= TFT_eSPI();
// TFT_eSprite sprite = TFT_eSprite(&tft);
TFT_eSprite s0 = TFT_eSprite(&tft);
TFT_eSprite s1 = TFT_eSprite(&tft);
TFT_eSprite s2 = TFT_eSprite(&tft);
TFT_eSprite s3 = TFT_eSprite(&tft);
TFT_eSprite s4 = TFT_eSprite(&tft);
TFT_eSprite spr = TFT_eSprite(&tft);

FT3168 touch(I2C_SDA, I2C_SCL, TP_RST, TP_INT);
int deb=0;
int chosen=0;  // chosen shape , background, text, circle
unsigned short grays[24];
unsigned short onOffColo[2]={TFT_RED,TFT_GREEN};
unsigned short tmpColors[3];
String lbl[3]={"B","T","S"};
int slider[3][3];// each slider value 0-400 becouse touch region is 400px
int value[3][3]={{20,20,20},
                 {200,230,200},
                 {50,60,150}};  // variable taht stores value for each slider 0-255
int brightnes=120;
//==========Display and touch======//

void listDir(fs::FS &fs, const char *dirname, uint8_t levels)
{
 root = fs.open("/","r");
 root.rewindDirectory();
      
  while (true)
  {
    File entry =  root.openNextFile();
    if (! entry)
    {break;}
   
    tmp=entry.name();
    name[numTabs]="/"+tmp;
    Serial.println(entry.name());
    // entry.close();
    numTabs++;
  }

  // drawJpeg("/AA.jpg", 0, 0); 
}


void inline setCS()
{
    digitalWrite(TFT_QSPI_CS, LOW);
}



void inline clrCS()
{
    digitalWrite(TFT_QSPI_CS, HIGH);
}

void writeCommand(uint32_t cmd, uint8_t *pdat, uint32_t length)
{
    // QSPI
    setCS();
    spi_transaction_t t;
    memset(&t, 0, sizeof(t));
    t.flags = (SPI_TRANS_MULTILINE_CMD | SPI_TRANS_MULTILINE_ADDR);
    t.cmd = 0x02;
    t.addr = cmd << 8;
    if (length != 0) {
        t.tx_buffer = pdat;
        t.length = 8 * length;
    } else {
        t.tx_buffer = NULL;
        t.length = 0;
    }
    // spi_device_polling_transmit(spi, &t);
    clrCS();
}

static int jpegDrawCallback(JPEGDRAW *pDraw)
{
    sprite.pushImage(pDraw->x, pDraw->y, pDraw->iWidth, pDraw->iHeight,pDraw->pPixels);
    return 1;
}

void setBrightness(uint8_t level)
{
    _brightness = level;
    lcd_cmd_t t = {0x51, {level}, 0x01};
    writeCommand(0x51, t.data, 0x01);
}

void draw()
{
  spr.fillSprite(TFT_BLACK);
  //spr.fillSprite(tft.color565(value[0][0], value[0][1], value[0][2]));
  spr.loadFont(fatFont);
  spr.setTextColor(grays[10],TFT_BLACK);
  spr.drawString("R: ",0,0);
  spr.drawString("G: ",0,30);
  spr.drawString("B: ",0,60);

  spr.setTextColor(grays[5],TFT_BLACK);
  spr.drawString(String(value[chosen][0]),26,0);
  spr.drawString(String(value[chosen][1]),26,30);
  spr.drawString(String(value[chosen][2]),26,60);
  
 
  spr.fillRect(112,80,120,30,0xCE01);
  spr.setTextColor(TFT_BLACK,0xCE01);
  tmpColors[chosen]=tft.color565(value[chosen][0], value[chosen][1], value[chosen][2]);
 
  spr.drawString("0x"+String(tmpColors[chosen],HEX),130,83);
   spr.unloadFont();
    spr.loadFont(smallFont);
    spr.setTextColor(0xBD41,TFT_BLACK);
    spr.drawString("BCKLIGHT: "+String(brightnes),0,92);
    spr.unloadFont();


    spr.fillSmoothRoundRect(100, 0, 132, 74, 4, tmpColors[0],TFT_BLACK);
     spr.fillRoundRect(74, 30, 32, 44, 4, tmpColors[0]);
    spr.loadFont(smallFont);
    spr.setTextColor(tmpColors[1],tmpColors[0]);
    spr.drawString(Str_cardSize+" QMI8658",116,4);
    spr.unloadFont();
    spr.loadFont(smallFont);
    spr.drawString("x:"+QMI8658_get_A_x()+"|y:"+ QMI8658_get_A_y(),83,42);
       spr.setTextColor(grays[6],grays[15]);
       spr.fillSmoothRoundRect(74, 0, 22, 26, 2, grays[15]);
       spr.drawString(lbl[chosen],80,4);
    spr.unloadFont();
    spr.fillRect(190,4,30,26,tmpColors[2]);
    spr.fillRect(200,36,18,24,tmpColors[2]);
  lcd_PushColors(0, 0, 240, 120, (uint16_t *)spr.getPointer());
}

void drawGraRect(int16_t x, int16_t y, int leng, uint16_t color_start, uint16_t color_end,TFT_eSprite &sprite) {

  for(int i=0;i<25;i++)
  if(i%6==0)
  sprite.drawWedgeLine(4,y-(i*16),18,y-(i*16),2,2,0x8430);
  else
  sprite.drawWedgeLine(10,y-(i*16),14,y-(i*16),1,1,0x8430);

  sprite.drawWedgeLine(x+5, y, x+5, 10, 5, 5,0x39E7,TFT_BLACK);
  sprite.drawSpot(x+5, y, 5, color_start);
  for (int16_t i = 0; i <= leng; i++) {
    // Interpolacija boje između početne i završne boje
    uint8_t interpolation = map(i, 0, leng, 0, 255);
    uint8_t red = map(interpolation, 0, 255, (color_start >> 8) & 0xF8, (color_end >> 8) & 0xF8);
    uint8_t green = map(interpolation, 0, 255, (color_start >> 3) & 0xFC, (color_end >> 3) & 0xFC);
    uint8_t blue = map(interpolation, 0, 255, (color_start << 3) & 0xF8, (color_end << 3) & 0xF8);
    uint16_t color = tft.color565(red, green, blue);

  sprite.fillRect(x,y-i,10,1,color); 
  }
  sprite.fillSmoothCircle(x+5, y-leng, 14,TFT_SILVER, TFT_BLACK);
  sprite.fillSmoothCircle(x+5, y-leng, 7,color_start,TFT_SILVER);
}


void draw1()
{
  s1.fillSprite(TFT_BLACK);
  s1.fillSmoothRoundRect(2,2,56,406,3,0x18E3,TFT_BLACK);
  drawGraRect(36, 400,slider[chosen][0], 0x6061, 0xFB92,s1);
  lcd_PushColors(0, 116, 60, 420, (uint16_t *)s1.getPointer());
}

void draw2()
{
  s2.fillSprite(TFT_BLACK);
  s2.fillSmoothRoundRect(2,2,56,406,3,0x18E3,TFT_BLACK);
  drawGraRect(36, 400,slider[chosen][1], 0x0A26, 0x1FD7,s2);
  lcd_PushColors(60, 116, 60, 420, (uint16_t *)s2.getPointer());
}

void draw3()
{
  s3.fillSprite(TFT_BLACK);
  s3.fillSmoothRoundRect(2,2,56,406,3,0x18E3,TFT_BLACK);
  drawGraRect(36, 400,slider[chosen][2], 0x02B0, 0x1D5E,s3);
  lcd_PushColors(120, 116, 60, 420, (uint16_t *)s3.getPointer());
}

void draw4()
{
  s4.fillSprite(TFT_BLACK);
  s4.fillSmoothRoundRect(2,2,56,406,3,0x18E3,TFT_BLACK);
  drawGraRect(36, 400,map(brightnes,0,255,0,384), 0x7B40, 0x8040,s4);
  lcd_PushColors(180, 116, 60, 420, (uint16_t *)s4.getPointer());
}


bool SD_A=1;
void setup() {

  Serial.begin(115200);
  PSRAM_Size = ESP.getPsramSize();
  // 流水灯引脚
  for(i=0;i<=s-1;i++)
  pinMode(led_pin[i], OUTPUT);

  QMI8658_Init();
    
  pinMode(SD_MISO_PIN, INPUT_PULLUP);
  SPI.begin(SD_SCLK_PIN, SD_MISO_PIN, SD_MOSI_PIN,SD_CS_PIN);
  if (!SD.begin(SD_CS_PIN,SPI, 40000000U, "/fs")) {
        Serial.printf("Failed to detect SD Card!!\n");
        SD_A=0;
  }
  if(SD_A==1){
    if (SD.cardType() != CARD_NONE) {
        Serial.printf("SD Card Size: %llu MB\n", SD.cardSize() / (1024 * 1024));  
    }
    listDir(SD, "/", 0);
    Serial.println("SD card initialized.");
  }
  
  // 初始化 SPIFFS 文件系统
  if (!SPIFFS.begin(true)) {
    Serial.println("SPIFFS initialization failed!");
    return;
  }
  Serial.println("SPIFFS initialized.");

  copyAllImagesToFlash();

  rm67162_init ();
  lcd_setRotation(0);
  sprite.createSprite(536,240);
  sprite.setSwapBytes(1);
  displayAllImages();
  s1.createSprite(60,420);
  s2.createSprite(60,420);
  s3.createSprite(60,420);
  s4.createSprite(60,420);
  spr.createSprite(240,120);

  //define level of grays or greys
  int co=240;
  for(int i=0;i<24;i++)
    {grays[i]=tft.color565(co, co, co);
     co=co-10;}

     for(int i=0;i<3;i++)
       {tmpColors[i]=tft.color565(value[i][0], value[i][1], value[i][2]);
       for(int j=0;j<3;j++)
       slider[i][j]=map(value[i][j],0,255,0,384);
       }

    draw();
      draw1();
        draw2();
          draw3();
            draw4();
}
bool SD_T=0,A=0; 
bool WIFI_BLE=1,WIFI_STA_T=1;
bool D1=1,D2=1;
bool LED_T=0,LED_TT=1,SD_TT=1;

void loop() {
//==========================================
  bool touched;
  uint8_t gesture;
  uint16_t xt, yt;

  // QMI8658_Loop();
  if((QMI8658_get_A_fy()<=-4.3 || LED_T ==1) && LED_TT == 1 ){
    delay(100);
    if(QMI8658_get_A_fy()<=-4.3 || LED_T ==1){
      LED_T=1;
      LED_Light_page();
      LED_light();
      if(QMI8658_get_A_fy() >=  3.7 )
      {
        SD_TT=0;
        LED_T=0;
        A=1;
      }
    }
  }
  else if(((QMI8658_get_A_fy()>=4.3 || SD_T == 1) && SD_A==0) && SD_TT==1){
    Memor_Display_page();
    SD_T=1;
    if(QMI8658_get_A_fy()<=-4.3){
      LED_TT = 0;
      SD_T=0;
      A=1;
    }
  }

  else if(((QMI8658_get_A_fy()>=4.3 || SD_T == 1) && SD_A==1) && SD_TT==1)
  {
    delay(100);
    if(QMI8658_get_A_fy()>=4.3 || SD_T == 1)
    {
      lcd_setRotation(1);
      SD_T=1;
      displayJPEG(fileName[number].c_str());
      lcd_PushColors(0, 0, 536, 240, (uint16_t*)sprite.getPointer());
      if(QMI8658_get_A_fx()>5.0){
        number++;
        if(number==numTabs2) 
          number=1;
    }
    else if(QMI8658_get_A_fx()<-3.5){
      if(number <= 0) 
        number=numTabs2;
      number--;
    }
    if(QMI8658_get_A_fy()<=-4.3){
      LED_TT = 0;
      SD_T=0;
      A=1;
    }
    }
  }
  else if(SD_T==0 && LED_T==0)
  {
     if(QMI8658_get_A_fy()>=0.2 && QMI8658_get_A_fy() <= 0.6){
      LED_TT = 1;
      SD_TT  = 1; 
     }
   

    if(QMI8658_get_A_fx()>5.0 && D1==1){

      if(QMI8658_get_A_fx() < -3.5)
      {
        D1=0;
      }
      
        //WIFIAP and BLE
      if(WIFI_BLE == 1){
        Wifi_Ble_page();
        bleKeyboard.begin();
        WiFi.softAP(ssid,password);
        delay(10);
        WIFI_BLE = 0;
      }
      else
        Wifi_Ble_OK_page();
      A=1;
      return;
    }
    else if(QMI8658_get_A_fx()<-3.5 && D2==1){
      if(QMI8658_get_A_fx() > 5.0)
      {
        D2=0;
      }
      if(WIFI_STA_T == 1){
        Wifi_STA_page();
        WiFi.begin("spotpear","12345678");
        while(WiFi.status() != WL_CONNECTED){
        delay(500);  
      } 
      Serial.print("IP地址为");
      Serial.println(WiFi.localIP());
      WIFI_STA_T = 0;
      }
      else
        Wifi_STA_OK_page();
      A=1;
      return;
    }
    lcd_setRotation(0);
    draw();
    if(A==1)
    {
      draw1();
        draw2();
          draw3();
            draw4();
      A=0;
      WIFI_BLE==1;
      D1=1;
    }
   touched = touch.getTouch(&xt, &yt, &gesture);
   if(touched)
   {
    if(yt>110){
    int end=map(yt,516,132,0,384);
    if(end>384) end=384;
    if(end<0) end=0;

    if(xt>0 && xt<60)
    {slider[chosen][0]=end; value[chosen][0]=map(end,0,384,0,255); draw1(); draw();}
     if(xt>60 && xt<120)
    {slider[chosen][1]=end;value[chosen][1]=map(end,0,384,0,255);  draw2();draw();}
     if(xt>120 && xt<180)
    {slider[chosen][2]=end;value[chosen][2]=map(end,0,384,0,255);draw3(); draw();}
     if(xt>180 && xt<240)
    {brightnes=map(end,0,384,0,255);draw4(); draw();}
    }

    if(yt<70)
    {
      if(deb==0)
      {deb=1; chosen++; if(chosen==3) chosen=0; draw(); draw1(); draw2(); draw3();}
    }
    }else deb=0;
  }
//============================================
}


void copyImageToFlash(const char *filename) {
    File sdFile = SD.open(filename, FILE_READ);
    if (!sdFile) {
        Serial.printf("无法打开文件 %s\n", filename);
        return;
    }

    String flashFilePath = "/";
    flashFilePath += filename;
    // 打开或创建 SPIFFS 中的目标文件
    File flashFile = SPIFFS.open(filename, FILE_WRITE);
    if (!flashFile) {
        sdFile.close();
        return;
    }

    const size_t bufferSize = 512;
    uint8_t buffer[bufferSize];
    size_t bytesRead;
    while ((bytesRead = sdFile.read(buffer, bufferSize)) > 0) {
        flashFile.write(buffer, bytesRead);
    }

    // 关闭文件
    sdFile.close();
    flashFile.close();
}

void copyAllImagesToFlash() {
    File root = SD.open("/");
    while (File file = root.openNextFile()) {
        if (!file.isDirectory()) {
            String fileName = file.name();
            if (fileName.endsWith(".jpg") || fileName.endsWith(".jpeg") || fileName.endsWith(".png")) {
                String fileName_A = "/";
                fileName_A += fileName;
                copyImageToFlash(fileName_A.c_str());
            }
        }
        file.close();
    }
}

void displayJPEG(const char *filename) {
  String path = "/";
  path += filename;
  Serial.println(path);
  File jpegFile = SPIFFS.open(path.c_str(), FILE_READ);  // 打开 SPIFFS 中的图片文件
  if (!jpegFile) {
    Serial.print("无法打开图片文件：");
    Serial.println(path);
    return;
  }

  // 使用 JPEGDecoder 解码文件
  if (JpegDec.decodeFsFile(path)) {
    Serial.println("JPEG 文件成功解码。");

    // 获取图片尺寸
    uint16_t w = JpegDec.width;
    uint16_t h = JpegDec.height;
    Serial.print("图片尺寸：");
    Serial.print(w);
    Serial.print("x");
    Serial.println(h);


    // 设置显示位置
    int x = 0;
    int y = 0;

    // 逐个 MCU block 解码并绘制到 sprite
    while (JpegDec.read()) {
      uint16_t *pImg = JpegDec.pImage;  // 获取当前 MCU 的像素数据
      int16_t mcu_x = JpegDec.MCUx * JpegDec.MCUWidth;
      int16_t mcu_y = JpegDec.MCUy * JpegDec.MCUHeight;

      sprite.pushImage(mcu_x, mcu_y, JpegDec.MCUWidth, JpegDec.MCUHeight, pImg);
    }

  } else {
    Serial.println("JPEG 文件解码失败。");
  }

  jpegFile.close();  // 关闭文件
}

void displayAllImages() {
  File root = SPIFFS.open("/");  // 打开 SPIFFS 根目录
  while (File file = root.openNextFile()) {
    if (!file.isDirectory()) {
      fileName[numTabs2] = file.name();
      if (fileName[numTabs2].endsWith(".jpg") || fileName[numTabs2].endsWith(".jpeg")) {
        Serial.print("显示图片：");
        Serial.println(fileName[numTabs2]);
        numTabs2++;
      }
    }
    file.close();
  }
}
void LED_light()
{
  
  for(a=0;a<=s-1;a++)
  {
    if(((QMI8658_get_A_fy()>=4.3 || SD_T == 1) && SD_A==1) && SD_TT==1)
      return;
    digitalWrite(led_pin[a], HIGH);  
    delay(T);
    digitalWrite(led_pin[a], LOW);  
    delay(T);
  }
  // 流回来，则不需要两边点亮
  for(b=s-2;b>=1;b--)
  {
    if(((QMI8658_get_A_fy()>=4.3 || SD_T == 1) && SD_A==1) && SD_TT==1)
      return;
    digitalWrite(led_pin[b], HIGH); 
    delay(T);
    digitalWrite(led_pin[b], LOW);  
    delay(T);
  }
}

void Memor_Display_page()
{
  lcd_setRotation(1);
  sprite.fillSprite(TFT_BLACK);
  sprite.loadFont(fatFont);
  sprite.drawString("FLASH:",15,0);
  sprite.drawString(String(ESP.getFlashChipSize() / (1024 * 1024)),150,0);
  sprite.drawString("MB",200,0);
  sprite.drawString("PSRAM: ",15,40);
  sprite.drawString(String(PSRAM_Size  / (1024 * 1020)),150,40);
  sprite.drawString("MB",200,40);
  sprite.drawString("SDCard: ",15,80);
  if(SD_A == 1){
    sprite.drawString(String(cardSize / (1024 * 1024)),100,80);
    sprite.drawString("MB",150,80);
  }
  else{
    sprite.drawString("No SDcard",150,80);
  }
  sprite.unloadFont();
  lcd_PushColors(0, 0, 536, 240, (uint16_t*)sprite.getPointer());
}

void Wifi_Ble_page()
{
  lcd_setRotation(1);
  sprite.fillSprite(TFT_BLACK);
  sprite.loadFont(fatFont);
  sprite.drawString("WIFI AP and Bluetooth testing:",15,0);
  sprite.drawString("Turn on the phone's Wi-Fi, connect to Wi-Fi: ESP32S3-AMOLED-1.91, and the Wi-Fi password is: 88888888. Also, turn on Bluetooth to connect to the ESP32 keyboard.",15,40);
  sprite.unloadFont();
  lcd_PushColors(0, 0, 536, 240, (uint16_t*)sprite.getPointer());
  
}

void Wifi_STA_page()
{
  lcd_setRotation(1);
  sprite.fillSprite(TFT_BLACK);
  sprite.loadFont(fatFont);
  sprite.drawString("WIFI STA testing:",15,0);
  sprite.drawString("Turn on the phone's hotspot and connect to the hotspot named: spotpear, with the password: 12345678",15,40);
  sprite.unloadFont();
  lcd_PushColors(0, 0, 536, 240, (uint16_t*)sprite.getPointer());
}

void LED_Light_page()
{
  lcd_setRotation(1);
  sprite.fillSprite(TFT_BLACK);
  sprite.loadFont(fatFont);
  sprite.drawString("LED_Light_testing",15,0);
  sprite.unloadFont();
  lcd_PushColors(0, 0, 536, 240, (uint16_t*)sprite.getPointer());
}

void Wifi_Ble_OK_page()
{
  lcd_setRotation(1);
  sprite.fillSprite(TFT_BLACK);
  sprite.loadFont(fatFont);
  sprite.drawString("Wi-Fi and Bluetooth are already turned on.",15,0);
  sprite.drawString("Turn on the phone's Wi-Fi, connect to Wi-Fi: ESP32S3-AMOLED-1.91, and the Wi-Fi password is: 88888888. Also, turn on Bluetooth to connect to the ESP32 keyboard.",15,40);
  sprite.unloadFont();
  lcd_PushColors(0, 0, 536, 240, (uint16_t*)sprite.getPointer());
}

void Wifi_STA_OK_page()
{
  lcd_setRotation(1);
  sprite.fillSprite(TFT_BLACK);
  sprite.loadFont(fatFont);
  sprite.drawString("The WIFI_STA pin is connected to spotpear.",15,0);
  sprite.unloadFont();
  lcd_PushColors(0, 0, 536, 240, (uint16_t*)sprite.getPointer());

}